# Lykin Tutorial Series

Author: [@glyph](https://mycelial.technology/)

## Introduction

[lykin](https://git.coopcloud.tech/glyph/lykin) is a tutorial application funded by a Secure Scuttlebutt (SSB) community grant. It is intended to showcase one way in which an SSB client application can be written using the [golgi](https://git.coopcloud.tech/golgi-ssb/golgi) client library. This tutorial series walks the reader through the creation of the lykin application.

## Installments

 - [Part 1: Sbot and Web Server](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_1_sbot_rocket)
 - [Part 2: Subscription Form and Key Validation](https://git.coopcloud.tech/glyph/lykin_tutorial/src/branch/main/part_2_subscribe_form)
 - Part 3: Database and Follows
 - Part 4: Posts and Message Streams
 - Part 5: Task Loop
 - Part 6: UI Layout and Peers List
 - Part 7: Latest Posts and Names
 - Part 8: Post List and Post Content
 - Part 9: Read, Unread and Delete
 - Part 10: Extension Ideas and Conclusion

## Links

 - [Scuttlebutt Protocol Guide](https://ssbc.github.io/scuttlebutt-protocol-guide/)
 - [Scuttlebutt Treasure Map for Developers](https://dev.scuttlebutt.nz)
 - [golgi: Rust RPC Library](http://golgi.mycelial.technology/)

## Thanks

I am grateful to the Butts who voted to fund this work, all contributors to the [SSBC](https://opencollective.com/secure-scuttlebutt-consortium) and Erick Lavoie (`@elavoie` / `@IgYpd+tCtXnlE2tYX/8rR2AGt+P8svC98WH3MdYAa8Y=.ed25519`) in particular - both for partially funding this work and for developing and overseeing the community grant process.

## Contribute

If you wish to support my work on the Rust Scuttlebutt ecosystem, please consider contributing to my [Liberapay account](https://liberapay.com/glyph/).

Contributions to the [Secure Scuttlebutt Consortium OpenCollective](https://opencollective.com/secure-scuttlebutt-consortium) are also encouraged.

## License

This tutorial series is shared under a [Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International (CC BY-NC-SA 4.0)](https://creativecommons.org/licenses/by-nc-sa/4.0/) license, while all code is licensed as MIT.
